ListKong/Controllers/CompanyController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using ListKong.Models;
using ListKong.Utility;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;

namespace ListKong.Controllers
{
    [Authorize]
    public class CompanyController : Controller
    {
        #region Controller Properties
        private IConfiguration _configuration;
        private CommonHelper _objHelper;
        private SQLGateway _objDataHelper;
        public string cnnect;
        public string keyForEncrypt, encryptedToken, encryptedEmail, formFlag;

        public CompanyController(IConfiguration configuration)
        {
            this._configuration = configuration;
            this._objDataHelper = new SQLGateway(this._configuration.GetConnectionString("DefaultConnection"));
            this._objHelper = new CommonHelper(this._configuration);
            cnnect = this._configuration.GetConnectionString("DefaultConnection");
        }
        #endregion
        public async Task<IActionResult> Index()
        {
            try
            {
                DataTable _dtResponseP = CompanyList();
                if (this._objHelper.checkDBNullResponse(_dtResponseP))
                {
                    List<CompanyListModel> lst = new List<CompanyListModel>();
                    lst = ExtensionMethods.DataTableToList<CompanyListModel>(_dtResponseP);
                    return View(lst);
                }
            }
            catch (Exception ex)
            {
                string E = ex.Message.ToString();
                return View();
            }
            return View();
        }
        public async Task<IActionResult> AddCompany()
        {
            CompanyModel model = new CompanyModel();            
            return View(model);
        }
        [HttpPost]
        public async Task<IActionResult> AddCompany(CompanyModel model)
        {

            if (!ModelState.IsValid)
            {
                return View();
            }
            try
            {
                var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
                List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
                parameters.Add(new KeyValuePair<string, string>("@userId", userId));
                parameters.Add(new KeyValuePair<string, string>("@Address", Convert.ToString(model.Address)));
                parameters.Add(new KeyValuePair<string, string>("@CompanyName", Convert.ToString(model.CompanyName)));
                parameters.Add(new KeyValuePair<string, string>("@ContactName", model.ContactName));
                parameters.Add(new KeyValuePair<string, string>("@Email", model.Email));
                parameters.Add(new KeyValuePair<string, string>("@LocationName", model.LocationName));
                parameters.Add(new KeyValuePair<string, string>("@LocationDescription", model.LocationDescription));
                DataTable dt = _objDataHelper.ExecuteProcedure("app_Add_New_Company", parameters);
                if (dt != null && dt.Rows.Count > 0)
                {
                    ViewData["SuccessMessage"] = "Company successfully added!";
                }
              
                //RedirectToAction("AddInventory");
                TempData["SuccessMessage"] = "Company successfully added!";
                return RedirectToAction("Index");
            }
            catch (Exception ex)
            {
                string msg = ex.Message.ToString();
            }
            return View();
        }
       
        public async Task<IActionResult> Edit(long? id)
        {
            CompanyModel model = new CompanyModel();
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@CompanyId", Convert.ToString(id)));
            DataSet ds = _objDataHelper.ExecuteProcedureWithDataSet("app_Get_Company_By_Id", parameters);
            if (ds.Tables.Count > 0)
            {
                if (ds.Tables[0].Rows.Count > 0)
                {
                    model.CompanyId = Convert.ToInt32(id);
                    model.CompanyName = Convert.ToString(ds.Tables[0].Rows[0]["CompanyName"]);
                    model.LocationName = Convert.ToString(ds.Tables[0].Rows[0]["LocationName"]);
                    model.Address = Convert.ToString(ds.Tables[0].Rows[0]["Address"]);
                    model.ContactName = Convert.ToString(ds.Tables[0].Rows[0]["ContactName"]);
                    model.Email = Convert.ToString(ds.Tables[0].Rows[0]["Email"]);
                    model.LocationDescription = Convert.ToString(ds.Tables[0].Rows[0]["LocationDescription"]);
                }
            }
            return  View(model);
        }
        [HttpPost]
        public async Task<IActionResult> Edit(CompanyModel model)
        {
            if (!ModelState.IsValid)
            {
                return View(model);
            }
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            parameters.Add(new KeyValuePair<string, string>("@companyId", Convert.ToString(model.CompanyId)));
            parameters.Add(new KeyValuePair<string, string>("@CompanyName", Convert.ToString(model.CompanyName)));
            parameters.Add(new KeyValuePair<string, string>("@LocationName", model.LocationName));
            parameters.Add(new KeyValuePair<string, string>("@Address", model.Address));
            parameters.Add(new KeyValuePair<string, string>("@ContactName", Convert.ToString(model.ContactName)));
            parameters.Add(new KeyValuePair<string, string>("@Email", model.Email));
            parameters.Add(new KeyValuePair<string, string>("@LocationDescription", model.LocationDescription));
            DataTable dt = _objDataHelper.ExecuteProcedure("app_Update_Company", parameters);
            if (dt != null && dt.Rows.Count > 0)
            {
                ViewData["SuccessMessage"] = "Company successfully updated!";
            }
            TempData["SuccessMessage"] = "Company successfully updated!";
            return RedirectToAction("Index");
        }
        public DataTable CompanyList()
        {
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            return _objDataHelper.ExecuteProcedure("app_Get_All_Company_By_Admin_User", parameters);
        }
    }
}

ListKong/Controllers/InventoryController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using ListKong.Models;
using ListKong.Utility;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;

namespace ListKong.Controllers
{
    [Authorize]
    public class InventoryController : Controller
    {
        #region Controller Properties
        private IConfiguration _configuration;
        private CommonHelper _objHelper;
        private SQLGateway _objDataHelper;
        public string cnnect;
        public string keyForEncrypt, encryptedToken, encryptedEmail, formFlag;

        public InventoryController(IConfiguration configuration)
        {
            this._configuration = configuration;
            this._objDataHelper = new SQLGateway(this._configuration.GetConnectionString("DefaultConnection"));
            this._objHelper = new CommonHelper(this._configuration);
            cnnect = this._configuration.GetConnectionString("DefaultConnection");
        }
        #endregion
        public IActionResult Index()
        {
            try
            {
                DataTable _dtResponseP = InventoryList();
                if (this._objHelper.checkDBNullResponse(_dtResponseP))
                {
                    List<InventoryListModel> lst = new List<InventoryListModel>();
                    lst = ExtensionMethods.DataTableToList<InventoryListModel>(_dtResponseP);
                    return View(lst);
                }
            }
            catch (Exception ex)
            {
                string E = ex.Message.ToString();
                return View();
            }
            return View();
        }
        public IActionResult AddInventory()
        {
            InventoryModel model = new InventoryModel();
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            var role = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.microsoft.com/ws/2008/06/identity/claims/role").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            parameters.Add(new KeyValuePair<string, string>("@role", role));
            DataTable dt = _objDataHelper.ExecuteProcedure("app_Get_Company_Location_By_User_Id", parameters);
            if (dt != null && dt.Rows.Count > 0)
            {
                model.InvCompanyID = Convert.ToInt32(dt.Rows[0]["CompanyID"]);
                model.InvLocationID = Convert.ToInt32(dt.Rows[0]["LocID"]);
                model.CompanyName = Convert.ToString(dt.Rows[0]["cCompanyName"]);
                model.LocationName = Convert.ToString(dt.Rows[0]["LocName"]);
            }
            if (role == "Admin")
            {
                ViewData["CompanyByAdminUser"] = CompanyList();
            }


            return View(model);
        }

        [HttpPost]
        public IActionResult AddInventory(InventoryModel model)
        {
            var role = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.microsoft.com/ws/2008/06/identity/claims/role").Value;
            if (!ModelState.IsValid)
            {
                if (role == "Admin")
                {
                    ViewData["CompanyByAdminUser"] = CompanyList();
                }
                return View(model);
            }
            try
            {
                var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
                List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
                parameters.Add(new KeyValuePair<string, string>("@userId", userId));
                parameters.Add(new KeyValuePair<string, string>("@companyId", Convert.ToString(model.InvCompanyID)));
                parameters.Add(new KeyValuePair<string, string>("@locationId", Convert.ToString(model.InvLocationID)));
                parameters.Add(new KeyValuePair<string, string>("@inventoryName", model.InvName));
                parameters.Add(new KeyValuePair<string, string>("@inventoryDesc", model.InvDesc));
                DataTable dt = _objDataHelper.ExecuteProcedure("app_Add_New_Inventory", parameters);
                if (dt != null && dt.Rows.Count > 0)
                {
                    ViewData["SuccessMessage"] = "Inventory successfully added!";
                    model.InvID = Convert.ToInt32(dt.Rows[0]["InventoryID"]);
                }
                DataTable dtTemp = new DataTable();
                dtTemp.Columns.Add("ImageName", typeof(string));
                dtTemp.Columns.Add("ImagePath", typeof(string));
                foreach (var item in model.InventoryImages)
                {
                    string fileName = model.InvID + "_" + DateTime.Now.Day + DateTime.Now.Month + DateTime.Now.Year + '_' + item.InventoryImage.FileName;
                    string FilePath = FileUploadUtility.UploadFile(item.InventoryImage, Convert.ToString(model.InvCompanyID), fileName);
                    dtTemp.Rows.Add(fileName, FilePath);
                }
                using (SqlConnection db = new SQLGateway(cnnect).CreateConnection())
                {
                    using (SqlCommand cmd = new SqlCommand("app_Add_Inventory_Images"))
                    {
                        cmd.Connection = db;
                        cmd.CommandType = CommandType.StoredProcedure;
                        cmd.Parameters.AddWithValue("@InventoryId", model.InvID);
                        cmd.Parameters.AddWithValue("@CreatedBy", userId);
                        cmd.Parameters.AddWithValue("@InventoryImageTableType", dtTemp);
                        db.Open();
                        cmd.ExecuteNonQuery();
                        db.Close();
                        cmd.Dispose();
                    }
                }
                //RedirectToAction("AddInventory");
                TempData["SuccessMessage"] = "Inventory successfully added!";
                return RedirectToAction("Index");
            }
            catch (Exception ex)
            {
                string msg = ex.Message.ToString();
            }
            return View();
        }

        public IActionResult Edit(string Id)
        {
            InventoryModel model = new InventoryModel();
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@InvID", Id));
            DataSet ds = _objDataHelper.ExecuteProcedureWithDataSet("app_Get_Inventory_By_Id", parameters);
            if (ds.Tables.Count > 0)
            {
                if (ds.Tables[0].Rows.Count > 0)
                {
                    model.InvID = Convert.ToInt32(Id);
                    model.CompanyName = Convert.ToString(ds.Tables[0].Rows[0]["CompanyName"]);
                    model.LocationName = Convert.ToString(ds.Tables[0].Rows[0]["LocationName"]);
                    model.InvCompanyID = Convert.ToInt32(ds.Tables[0].Rows[0]["InvCompanyID"]);
                    model.InvLocationID = Convert.ToInt32(ds.Tables[0].Rows[0]["InvLocationID"]);
                    model.InvName = Convert.ToString(ds.Tables[0].Rows[0]["InvName"]);
                    model.InvDesc = Convert.ToString(ds.Tables[0].Rows[0]["InvDesc"]);
                    model.InvCreatedDate = Convert.ToDateTime(ds.Tables[0].Rows[0]["InvCreatedDate"]);
                }
                if (ds.Tables[1].Rows.Count > 0)
                {
                    model.InventoryImages = new List<InventoryImageModel>();
                    foreach (DataRow item in ds.Tables[1].Rows)
                    {
                        InventoryImageModel imageModel = new InventoryImageModel(); 
                        imageModel.FileName ="/"+ Path.Combine(Convert.ToString(item["ImagePath"]), Convert.ToString(item["ImageName"]));
                        imageModel.FilePath = Convert.ToString(item["ImagePath"]);
                        imageModel.ImageId = Convert.ToInt64(item["ImageId"]);
                        model.InventoryImages.Add(imageModel);
                    }
                }
            }
            return View(model);
        }
        [HttpPost]
        public IActionResult Edit(InventoryModel model)
        {
            if (!ModelState.IsValid)
            {
                return View(model);
            }
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            parameters.Add(new KeyValuePair<string, string>("@companyId", Convert.ToString(model.InvCompanyID)));
            parameters.Add(new KeyValuePair<string, string>("@locationId", Convert.ToString(model.InvLocationID)));
            parameters.Add(new KeyValuePair<string, string>("@inventoryName", model.InvName));
            parameters.Add(new KeyValuePair<string, string>("@inventoryDesc", model.InvDesc));
            parameters.Add(new KeyValuePair<string, string>("@InvID", Convert.ToString(model.InvID)));
            DataTable dt = _objDataHelper.ExecuteProcedure("app_Update_Inventory", parameters);
            if (dt != null && dt.Rows.Count > 0)
            {
                ViewData["SuccessMessage"] = "Inventory successfully updated!";
                model.InvID = Convert.ToInt32(dt.Rows[0]["InventoryID"]);
            }
            TempData["SuccessMessage"] = "Inventory successfully updated!";
            return RedirectToAction("Index");

ListKong/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - ListKong</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
        <link rel="stylesheet" href="~/css/site.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute" />
        <link rel="stylesheet" href="~/css/site.min.css" asp-append-version="true" />
    </environment>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" />
    <link rel="stylesheet" href="//cdn.jsdelivr.net/npm/alertifyjs@1.13.1/build/css/alertify.min.css">
</head>
<body>
    <nav class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                <a asp-area="" asp-controller="Home" asp-action="Index" class="navbar-brand">ListKong</a>
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li><a asp-area="" asp-controller="Home" asp-action="Index">Home</a></li>
                    <li><a asp-area="" asp-controller="Home" asp-action="About">About</a></li>
                    <li><a asp-area="" asp-controller="Home" asp-action="Contact">Contact</a></li>
                    @if (User.Identity.IsAuthenticated)
                    {
                        if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Company" asp-action="Index">Manage Company</a>
                            </li>
                        }
                        if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="CompanyUser" asp-action="Index">Manage User</a>
                            </li>
                        }
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Inventory" asp-action="Index">Manage Inventory</a>
                        </li>
                    }
                </ul>
                @await Html.PartialAsync("_LoginPartial")
            </div>
        </div>
    </nav>
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; 2020 - ListKong</p>
        </footer>
    </div>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-2.2.0.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha384-K+ctZQ+LL8q6tP7I94W+qzQsfRV2a+AfHIi9k8z8l9ggpc8X+Ytst4yBo/hH+8Fk">
        </script>
        <script src="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa">
        </script>
        <script src="~/js/site.min.js" asp-append-version="true"></script>
    </environment>

    @RenderSection("Scripts", required: false)
</body>
</html>